#import "RegistrationDropBox.h"
#import "AquaticPrime.h"
#import "MyMainWindow.h"
#import "AppController.h"

@implementation RegistrationDropBox


- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
	{
	NSPasteboard *pboard = [sender draggingPasteboard];
	if ([[pboard types] containsObject:@"NSFilenamesPboardType"])
		{
		NSString *fileString = [[pboard propertyListForType:NSFilenamesPboardType] objectAtIndex:0];	
		if ([[fileString pathExtension] isEqualToString:@"TestFile"])
			{
			return NSDragOperationCopy;
			}
			else
			{
			return NSDragOperationNone;
			}
		}
		else
		{
		return NSDragOperationNone;
		}
	}


- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender
	{
	return YES;
	}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
	{
   	NSPasteboard *pboard = [sender draggingPasteboard];
	NSString *dropedFilePath = [[pboard propertyListForType:NSFilenamesPboardType] objectAtIndex:0];
	NSString *droppedFileContents = [NSString stringWithContentsOfFile:dropedFilePath];
	NSLog(droppedFileContents);

	// This string is specially constructed to prevent key replacement 	// *** Begin Public Key ***
	NSMutableString *key = [NSMutableString string];
	[key appendString:@"0xA7B5841AB78ADB7A4A2C54"];
	[key appendString:@"0"];
	[key appendString:@"0"];
	[key appendString:@"F907"];
	[key appendString:@"156B6530DF6B6E5"];
	[key appendString:@"A"];
	[key appendString:@"A"];
	[key appendString:@"D9A63F023A327"];
	[key appendString:@"4C4D7CF6CF820B57B6BDE8FC7"];
	[key appendString:@"2"];
	[key appendString:@"2"];
	[key appendString:@"E67"];
	[key appendString:@"F"];
	[key appendString:@"9"];
	[key appendString:@"9"];
	[key appendString:@"1C3E36470477F79A7E2C3B9800F"];
	[key appendString:@"21B62B1D"];
	[key appendString:@"1"];
	[key appendString:@"1"];
	[key appendString:@"A12BA373C211378A84F4"];
	[key appendString:@"D6A0E3EC0A38EBE2358082F3D7A5F5"];
	[key appendString:@"D3A5"];
	[key appendString:@"C"];
	[key appendString:@"C"];
	[key appendString:@"78057CCFD3ABC4DB31719C46"];
	[key appendString:@"1CE5F470370814DF4F6CA3A8C3E68D"];
	[key appendString:@"1C4BD8179FA72644D9"];
	// *** End Public Key *** 
	
	AquaticPrime *licenseValidator = [AquaticPrime aquaticPrimeWithKey:key];
	NSData *licenseData = [droppedFileContents dataUsingEncoding:NSUnicodeStringEncoding];
	NSDictionary *licenseDictionary = [licenseValidator dictionaryForLicenseData:licenseData];
	
	
	
	
	
	
	
	
	
	
	
	if (licenseDictionary == nil)
		{
		NSLog(@"File Is Not Valid");	//This Displays In The Console Correctly
		[appController beep];		//This Doesn't Get Called
		}
		else
		{
		NSLog(@"File Is Valid");
		}
		
	return YES;
	}











- (void)concludeDragOperation:(id <NSDraggingInfo>)sender
	{
	[self setNeedsDisplay:YES];
	}

- (id)initWithFrame:(NSRect)frame
	{
	self = [super initWithFrame:frame];
	[self registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, nil]];
	return self;
	}

- (void)dealloc
	{
	[self unregisterDraggedTypes];
	[super dealloc];
	}

@end
